<?php
/*
+----------------------------------------------------------------+
|																 |
|	WordPress 2.8 Plugin: WP-PhotoContest 1.0                    |
|	Copyright (c) 2009 Frank van der Stad						 |
|																 |
|	File Written By:											 |
|	- Frank van der Stad										 |
|	- http://www.vanderstad.nl/wp-photocontest					 |
|																 |
|	File Information:											 |
|	- Add PhotoContest											 |
|	- wp-content/plugins/wp-photocontest/photocontest-add.php	 |
|																 |
+----------------------------------------------------------------+
*/


### Check Whether User Can Manage PhotoContest
if(!current_user_can('manage_photocontest')) {
	die('Access Denied');
}

### Include the configfile
require_once(dirname(__FILE__).'/wp-photocontest-config.php');

### PhotoContest Manager
$base_name		= plugin_basename('wp-photocontest/photocontest-manager.php');
$base_name_add	= str_replace('manager','add',plugin_basename('wp-photocontest/photocontest-manager.php'));
$base_name_cfg	= str_replace('manager','settings',plugin_basename('wp-photocontest/photocontest-manager.php'));
$base_page 		= 'admin.php?page='.$base_name;
$base_page_add	= 'admin.php?page='.$base_name_add;
$base_page_cfg	= 'admin.php?page='.$base_name_cfg;

### Variables
$checkArray = 	array(
					"do"=>"",
					"WP_USE_THEMES"=>"",
					"DEBUG_FLAG"=>"",
					"CONTESTS_PATH"=>"",
					"CONTESTS_SKIN"=>"",
					"DEFAULT_STATUS"=>"",
					"user"=>"",
					"parent_id"=>"",
					"DEFAULT_PAGENAME"=>"",
					"DEFAULT_TYPE"=>"",
					"DEFAULT_COMMENTS"=>"",
					"VOTING_METHOD"=>"",
					"VIEWIMG_BOX"=>"",
				);

$_REQUEST = array_merge($checkArray,$_REQUEST);
$action						= wppc_checkOptions($_REQUEST['do'],array(__('Save settings', 'wp-photocontest')));
$WP_USE_THEMES 				= wppc_checkOptions($_REQUEST['WP_USE_THEMES'], array('true','false'), WP_USE_THEMES);
$DEBUG_FLAG 				= wppc_checkOptions($_REQUEST['DEBUG_FLAG'], array('0','1'),DEBUG_FLAG);
$CONTESTS_PATH 				= wppc_checkString($_REQUEST['CONTESTS_PATH'], CONTESTS_PATH);
$CONTESTS_SKIN 				= wppc_checkString($_REQUEST['CONTESTS_SKIN'], CONTESTS_SKIN);
$DEFAULT_STATUS 			= wppc_checkOptions($_REQUEST['DEFAULT_STATUS'], array('publish','pending','draft'),DEFAULT_STATUS);
$DEFAULT_UID 				= wppc_checkInteger($_REQUEST['user'], DEFAULT_UID);
$DEFAULT_PARENT				= wppc_checkInteger($_REQUEST['parent_id'], DEFAULT_PARENT);
$DEFAULT_PAGENAME 			= wppc_checkString($_REQUEST['DEFAULT_PAGENAME'], DEFAULT_PAGENAME);
$DEFAULT_TYPE 				= wppc_checkOptions($_REQUEST['DEFAULT_TYPE'], array('page','post'),DEFAULT_TYPE);
$DEFAULT_COMMENTS 			= wppc_checkOptions($_REQUEST['DEFAULT_COMMENTS'], array('open','closed'),DEFAULT_COMMENTS);
$VOTING_METHOD 				= wppc_checkOptions($_REQUEST['VOTING_METHOD'], array('star5','star10','option5','option10','hidden'),VOTING_METHOD);
$VIEWIMG_BOX 				= wppc_checkInteger($_REQUEST['VIEWIMG_BOX'], VIEWIMG_BOX);
$EDIT_DATE 					= date('Y-m-d h:m:i');


### Add some vars
$show_form 		= true;


### Form Processing 
if(!empty($action)) {
	// Decide What To Do
	switch($action) {
		// Add PhotoContest
		case __('Save settings', 'wp-photocontest'):
			// Check if contest name is set
			$default_options = $wpdb->update
			(
				$wpdb->prefix.'photocontest_config',
				array( 
					'WP_USE_THEMES' => $WP_USE_THEMES,
					'DEBUG_FLAG' => $DEBUG_FLAG,
					'CONTESTS_PATH' => $CONTESTS_PATH,
					'CONTESTS_SKIN' => $CONTESTS_SKIN,
					'DEFAULT_STATUS' => $DEFAULT_STATUS,
					'DEFAULT_UID' => $DEFAULT_UID,
					'DEFAULT_PARENT' => $DEFAULT_PARENT,
					'DEFAULT_PAGENAME' => $DEFAULT_PAGENAME,
					'DEFAULT_TYPE' => $DEFAULT_TYPE,
					'DEFAULT_COMMENTS' => $DEFAULT_COMMENTS,
					'VOTING_METHOD' => $VOTING_METHOD,
					'VIEWIMG_BOX' => $VIEWIMG_BOX,
					'edit_date' => $EDIT_DATE,
				),
				array( 'option_id' => 1 )
			);

			if ($default_options)
			{
				$text .= '<p style="color: green;">'.__('Succes saving PhotoContest options.', 'wp-photocontest').'</p>';
				$text .= '<p style="color: green;"><a href="'.$base_page.'">'.__('Click here to continue', 'wp-photocontest').'</a></p>';
				$show_form = false;
			}
			else
			{
				//TODO: Rollback of directory and page
				$text .= '<p style="color: red;">'.__('Error saving PhotoContest options.', 'wp-photocontest').'</p>';
				$text .= '<p style="color: red;">'.__('Can\'t insert into the database', 'wp-photocontest').'</p>';
				$text .= '<p style="color: red;">'.wppc_printDatabaseError().'</p>';
				$show_form = false;			
			}
			
		break;
		
		default:
			// We don't have a valid action. Just show the add-form
		break;	
	}
}	


photocontest_scripts_and_styles();
?>
<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo plugin_basename(__FILE__); ?>">
<div class="wrap">
<?php
### Add PhotoContest Form
if(!empty($text)) { 
	echo '<!-- Last Action --><div id="message" class="updated fade">'.stripslashes($text).'</div>';
}
?>

<?php
if ($show_form)
{
	$option_sql = "SELECT * FROM ".$wpdb->prefix."photocontest_config LIMIT 0,1";
	$options_array = (array) $wpdb->get_row( $wpdb->prepare( $option_sql ));
	?>
	<div id="icon-wp-photocontest" class="icon32"><br /></div>
	<h2><?php _e('Config settings', 'wp-photocontest'); ?></h2>
	<!-- Contest info -->
	<h3><?php _e('Details', 'wp-photocontest'); ?></h3>
	<table class="form-table">
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('WP_USE_THEMES', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<?php
				$wpthemes_values = array('true'=>'True','false'=>'False');
				$selectstring = '<select name="WP_USE_THEMES">';
				foreach ($wpthemes_values as $status_k=>$status_v)
				{
					$_selected = '';
					if ($options_array['WP_USE_THEMES'] == $status_k)
					{
						$_selected = ' selected="selected"';
					}
					$selectstring .= '<option value="'.$status_k.'" '.$_selected.'>'.$status_v.'</option>';
				}
				$selectstring .= '</select>';
				echo $selectstring;
				unset($selectstring);
				?>
				<br />			
				<?php _e('Use Wordpress themes?', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('DEBUG_FLAG', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<?php
				$debug_values = array('1'=>'True','0'=>'False');
				$selectstring = '<select name="DEBUG_FLAG">';
				foreach ($debug_values as $status_k=>$status_v)
				{
					$_selected = '';
					if ($options_array['DEBUG_FLAG'] == $status_k)
					{
						$_selected = ' selected="selected"';
					}
					$selectstring .= '<option value="'.$status_k.'" '.$_selected.'>'.$status_v.'</option>';
				}
				$selectstring .= '</select>';
				echo $selectstring;
				unset($selectstring);
				?>
				<br />
				<?php _e('Print some debug ', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('CONTESTS_PATH', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<input name="CONTESTS_PATH" type="text" width="100" value="<?php echo $options_array['CONTESTS_PATH'];?>">
				<br />
				<?php _e('Defines where to store the photos uploaded by users.', 'wp-photocontest');?> <?php _e('(Relative to the wp-photocontest folder)', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('CONTESTS_SKIN', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<input name="CONTESTS_SKIN" type="text" width="100" value="<?php echo $options_array['CONTESTS_SKIN'];?>">
				<br />
				<?php _e('Defines which skin (kind of template) the plugin uses.', 'wp-photocontest');?> <?php _e('(Relative to the wp-photocontest folder)', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Status', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<?php
				$status_values = array('publish'=>__('Publish','wp-photocontest'),'pending'=>__('Pending','wp-photocontest'),'draft'=>__('Draft','wp-photocontest'));
				$selectstring = '<select name="DEFAULT_STATUS">';
				foreach ($status_values as $status_k=>$status_v)
				{
					$_selected = '';
					if ($options_array['DEFAULT_STATUS'] == $status_k)
					{
						$_selected = ' selected="selected"';
					}
					$selectstring .= '<option value="'.$status_k.'" '.$_selected.'>'.$status_v.'</option>';
				}
				$selectstring .= '</select>';
				echo $selectstring;
				unset($selectstring);
				?>
				<br />
				<?php _e('Defines the default status when creating a new contest.', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Poster', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<?php wp_dropdown_users(array('selected'=>$options_array['DEFAULT_UID']));?>
				<br />
				<?php _e('Defines the default author (UID) when creating a new contest.', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Page type', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<?php
				$type_values = array('page'=>__('Page','wp-photocontest'),'post'=>__('Post','wp-photocontest'));
				$selectstring = '<select name="DEFAULT_TYPE">';
				foreach ($type_values as $status_k=>$status_v)
				{
					$_selected = '';
					if ($options_array['DEFAULT_TYPE'] == $status_k)
					{
						$_selected = ' selected="selected"';
					}
					$selectstring .= '<option value="'.$status_k.'" '.$_selected.'>'.$status_v.'</option>';
				}
				$selectstring .= '</select>';
				echo $selectstring;
				unset($selectstring);
				?>
				<br />
				<?php _e('Defines the default type when creating a new contest.', 'wp-photocontest');?><br>
				<?php _e('page: The plugin creates a page which handles a contest.', 'wp-photocontest');?><br>
				<?php _e('post: The plugin creates a post which handles a contest.', 'wp-photocontest');?><br>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Page name', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<input name="DEFAULT_PAGENAME" type="text" width="100" value="<?php $options_array['DEFAULT_PAGENAME'] ?>">
				<br />
				<?php _e('Defines the default page/post name when creating a new contest', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Parent page', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<?php wp_dropdown_pages(array('exclude_tree' => 0, 'selected' => $options_array['DEFAULT_PARENT'], 'name' => 'parent_id', 'show_option_none' => __('Main Page (no parent)','wp-photocontest'), 'sort_column'=> 'menu_order, post_title')); ?>
				<br />
				<?php _e('Defines the default parent when creating a new contest', 'wp-photocontest');?> <?php _e('subpage of page where post is saved on) ', 'wp-photocontest');?>
			</td>
		</tr>				
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Comments', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<?php
				$comments_values = array('open'=>__('Open','wp-photocontest'),'closed'=>__('Closed','wp-photocontest'));
				$selectstring = '<select name="DEFAULT_COMMENTS">';
				foreach ($comments_values as $status_k=>$status_v)
				{
					$_selected = '';
					if ($options_array['DEFAULT_COMMENTS'] == $status_k)
					{
						$_selected = ' selected="selected"';
					}
					$selectstring .= '<option value="'.$status_k.'" '.$_selected.'>'.$status_v.'</option>';
				}
				$selectstring .= '</select>';
				echo $selectstring;
				unset($selectstring);					
				?>
				<br />
				<?php _e('Defines the default comments status when creating a new contest.', 'wp-photocontest');?><br>
				<?php _e('open: people can comment on a content/photo.', 'wp-photocontest');?><br>
				<?php _e('closed: people can\'t comment on a content/photo.', 'wp-photocontest');?><br>

			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('VOTING_METHOD', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<?php
				$comments_values = array('star5'=>'5 stars','star10'=>'10 stars','option5'=>'5 option list','option10'=>'10 option list','hidden'=>'Hidden');
				$selectstring = '<select name="VOTING_METHOD">';
				foreach ($comments_values as $status_k=>$status_v)
				{
					$_selected = '';
					if ($options_array['VOTING_METHOD'] == $status_k)
					{
						$_selected = ' selected="selected"';
					}
					$selectstring .= '<option value="'.$status_k.'" '.$_selected.'>'.$status_v.'</option>';
				}
				$selectstring .= '</select>';
				echo $selectstring;
				unset($selectstring);					
				?>			
				<br />			
				<?php _e('Defines the way the votes method is shown', 'wp-photocontest');?>
				<?php _e('star5: Star rating from 1-5', 'wp-photocontest');?>
				<?php _e('star10: Star rating from 1-10', 'wp-photocontest');?>
				<?php _e('hidden: Hidden vote of 1', 'wp-photocontest');?>
				<?php _e('option5: Option list from 1-5', 'wp-photocontest');?>
				<?php _e('option10: Option list from 1-10', 'wp-photocontest');?>			
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('VIEWIMG_BOX', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<input name="VIEWIMG_BOX" type="text" width="100" value="<?php echo $options_array['VIEWIMG_BOX'];?>">
				<br />
				<?php _e('Defines the height and width the pictures are generated.', 'wp-photocontest');?>
				<?php _e('Note: If you are using paddings, margins or borders in your style', 'wp-photocontest');?>
				<?php _e('distract this from your total size (I need 454 - 2px border - 10px', 'wp-photocontest');?>
				<?php _e('padding, so the result = 442px', 'wp-photocontest');?>				
			</td>
		</tr>
		
	</table>
	
	<p style="text-align: center;"><input type="submit" name="do" value="<?php _e('Save settings', 'wp-photocontest'); ?>"  class="button" />&nbsp;&nbsp;<input type="button" name="cancel" value="<?php _e('Cancel', 'wp-photocontest'); ?>" class="button" onclick="javascript:history.go(-1)" /></p>
<?php
}
?>
</div>
</form>
